CCTimerCommand = class(Turbine.ShellCommand);

function CCTimerCommand:Constructor(plugin)
	Turbine.ShellCommand.Constructor(self);

	self.plugin = plugin;
	self.window = plugin.window;
end

function CCTimerCommand:Execute(command, arguments)
	local args = snarfargs(arguments);

	if args[1] == "load" then
		table.remove(args, 1);
		if #args > 0 then
			self.window:LoadConfig(table.concat(args, " "));
		else
			Turbine.Shell.WriteLine("Configs: " .. table.concat(self.window:GetConfigs(), ", "));
		end
	elseif args[1] == "calibrate" then
		self.window:StartCalibrate();
	elseif args[1] == "options" then
		Turbine.PluginManager.ShowOptions(self.plugin);
	else
		Turbine.Shell.WriteLine("usage: /cctimer <load <config>|calibrate|options>");
	end
end

function CCTimerCommand:GetShortHelp()
	return self.plugin:GetName();
end