import "moebius92.CCTimer.CCTimerOptionsColorSelect";

CCTimerOptionsCCEntry = class(Turbine.UI.Control);

local function fnFocusGained(self, args) self:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); end
local function fnFocusLost(self, args) self:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight); self:SetText(self.value); end
local function fnKeyDown(self, args)
	if self:HasFocus() and args.Action == 162 then
		local x = self.outgoing(self:GetText());
		self.parent:Focus();

		if x ~= false then
			self.parent.parent:SetSetting(self.parent.shortcut, self.entry, x);
			self.parent:SetValue(self.entry, x);
		else
			self.parent:SetValue(self.entry, self.value);
		end
	end
end

function CCTimerOptionsCCEntry:Constructor(parent, regime, w, h, s, m, shortcut, entries, outgoing, incoming)
	Turbine.UI.Control.Constructor(self);

	self.parent = parent;
	self.regime = regime;
	self.shortcut = shortcut;

	local y = 0;

	self.regimeBack = Turbine.UI.Control();
	self.regimeBack:SetParent(self);
	self.regimeBack:SetPosition((w - (regime:GetWidth() + 4)) / 2, 0);
	self.regimeBack:SetSize(regime:GetWidth() + 4, regime:GetHeight() + 4);
	self.regimeBack:SetBackColor(Turbine.UI.Color(1.0, 0.5, 0.5, 0.5));
	regime:SetParent(self.regimeBack);
	regime:SetPosition(2, 2);
	y = y + regime:GetHeight() + 4 + m;

	self.quickslot = Turbine.UI.Lotro.Quickslot();
	self.quickslot:SetParent(self);
	self.quickslot:SetPosition((w - s) / 2 - 1, y - 1);
	self.quickslot:SetSize(s, s);
	self.quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Skill, shortcut));
	y = y + s + m;

	self.fields = { };
	for i, entry in ipairs(entries) do
		if entry ~= "" then
			self.fields[entry] = Turbine.UI.Lotro.TextBox();
			self.fields[entry].parent = self;
			self.fields[entry].entry = entry;
			self.fields[entry].outgoing = outgoing[i];
			self.fields[entry].incoming = incoming[i];
			self.fields[entry]:SetSize(w, h);
			self.fields[entry]:SetPosition(0, y);
			self.fields[entry]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
			self.fields[entry]:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			self.fields[entry]:SetWantsKeyEvents(true);
			self.fields[entry].FocusGained = fnFocusGained;
			self.fields[entry].FocusLost = fnFocusLost;
			self.fields[entry].KeyDown = fnKeyDown;
			self.fields[entry]:SetParent(self);
		end
		y = y + h + m;
	end

	self.color = CCTimerOptionsColorSelect(self, parent, shortcut, h);
	self.color:SetPosition((w - h) / 2, y);
	y = y + h + m;

	self:SetSize(w, y - m);
	self:SetParent(parent);
end

function CCTimerOptionsCCEntry:SetValue(entry, value)
	self.fields[entry].value = self.fields[entry].incoming(value);
	self.fields[entry]:SetText(self.fields[entry].value);
end