import "moebius92.CCTimer.CCTimerOptionsColorSelect";

CCTimerOptionsCCLabel = class(Turbine.UI.Control);

function CCTimerOptionsCCLabel:Constructor(parent, regime, w, h, s, m, labels)
	Turbine.UI.Control.Constructor(self);

	self.parent = parent;
	self.regime = regime;

	local y = 0;

	self.regimeBack = Turbine.UI.Control();
	self.regimeBack:SetParent(self);
	self.regimeBack:SetPosition((w - (regime:GetWidth() + 4)) / 2, 0);
	self.regimeBack:SetSize(regime:GetWidth() + 4, regime:GetHeight() + 4);
	self.regimeBack:SetBackColor(Turbine.UI.Color(1.0, 0.5, 0.5, 0.5));
	regime:SetParent(self.regimeBack);
	regime:SetPosition(2, 2);
	y = y + regime:GetHeight() + 4 + m;

	y = y + s + m;

	self.labels = { };
	for _, text in ipairs(labels) do
		local label = Turbine.UI.Label();
		label:SetPosition(0, y);
		label:SetSize(w, h);
		label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
		label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		label:SetFontStyle(Turbine.UI.FontStyle.Outline);
		label:SetText(text);
		label:SetParent(self);
		table.insert(self.labels, label);
		y = y + h + m;
	end

	self.colors = { };
	self.colors.back = CCTimerOptionsColorSelect(self, parent, "back", h);
	self.colors.back:SetPosition((w - 3 * h) / 2, y);
	self.colors.rec = CCTimerOptionsColorSelect(self, parent, "rec", h);
	self.colors.rec:SetPosition((w - 3 * h) / 2 + (2 * h), y);
	y = y + h + m;

	self:SetSize(w, y - m);
	self:SetParent(parent);
end