import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

function layout(items, fnPref, zones)
	local t = { };

	table.sort(items, function(a, b) return (a.top or -math.huge) > (b.top or -math.huge); end);

	if fnPref == nil then
		local max = 0;

		for _, v in ipairs(items) do
			if v.top ~= nil then
				v.lane = #t + 1;
				for b = 1, #t, 1 do
					if v.top <= t[b] then
						v.lane = b;
						break;
					end
				end
				t[v.lane] = v.bottom;
				if v.lane > max then
					max = v.lane;
				end
			else
				v.lane = nil;
			end
		end

		return max;
	else
		local tmax = { };
		local tend = { };
		local i = 1;
		local max = 0;
		local cur = 0;

		for _, v in ipairs(items) do
			if v.top ~= nil then
				while (#tend > 0 and tend[1] >= v.top) do
					cur = cur - 1;
					table.remove(tend, 1);
				end

				while (i <= #zones and zones[i] >= v.top) do
					tmax[i] = max;
					i = i + 1;
				end

				v.zone = i;
				cur = cur + 1;
				if max < cur then
					max = cur;
				end

				table.insert(tend, v.bottom);
				table.sort(tend, function(a, b) return a > b; end);
			else
				v.lane = nil;
			end
		end

		while i <= #zones do
			tmax[i] = max;
			i = i + 1;
		end
		tmax[i] = max;

		i = 1;
		for _, v in ipairs(items) do
			if v.top ~= nil then
				while (i <= #zones and zones[i] >= v.top) do
					i = i + 1;
				end

				v.pref = { };
				v.bestIndex = nil;
				v.best1 = 0;
				v.best2 = 0;
				for j = 1, tmax[i], 1 do
					v.pref[j] = fnPref(v, j);
					if v.pref[j] > v.best1 then
						v.best2 = v.best1;
						v.best1 = v.pref[j];
						v.bestIndex = j;
					elseif v.pref[j] > v.best2 then
						v.best2 = v.pref[j];
					end
				end
			end
		end

		for i, v in ipairs(items) do
			if v.top ~= nil then
				local j = i + 1;

				while j <= #items and (items[j].top or -math.huge) > v.bottom do
					for k = 1, #v.pref, 1 do
						if k == items[j].bestIndex then
							v.pref[k] = v.pref[k] + items[j].best2;
						else
							v.pref[k] = v.pref[k] + items[j].best1;
						end
					end
					j = j + 1;
				end
				v.range = j;
			end
		end

		for _, v in ipairs(items) do
			if v.top ~= nil then
				local b = nil;

				for i = 1, #v.pref, 1 do
					if v.top <= (t[i] or math.huge) then
						if (b == nil) or (v.pref[b] < v.pref[i]) then
							b = i;
						end
					end
				end
				t[b] = v.bottom;
				v.lane = b;
			end
		end

		return tmax;
	end
end